#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>


//------------------------------------------------------------------------------

#define MAX_CHAR 100LU		//Max # of characters in a character string.

//------------------------------------------------------------------------------

//fn prototypes

//functions for sorting a binary file of character strings
void qsort_binary_character_string_file ( int , long , unsigned int );
void qs_binary_character_string_file ( int , long , long , unsigned int );
int sort_it ( char * , unsigned int , long );

//var
char p[MAX_CHAR];

//------------------------------------------------------------------------------

int
main ( int argv, char **argc )
{

     long counter = 0L;
     char filename[100];
     unsigned int max_char = 0;

     if(argv != 4)
     {
        printf("Usage: ./qsort_file_of_binary_characterstrings filename max_length_of_a_characterstring number_of_characterstrings \n");
        printf("The output file is the original filename.\n");
        printf("Note that each binary character string must have max_length_of_a_characterstring characters, which may include blanks.\n");
     }

//------------------------------------------------------------------------------

     strcpy(filename,argc[1]);
     max_char = atoi(argc[2]);
     counter = atol(argc[3]);

//------------------------------------------------------------------------------

          sort_it ( filename, max_char, counter );

//------------------------------------------------------------------------------
     return 0;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//----------------------------End-of-main---------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------

int
sort_it ( char s[], unsigned int max_char , long counter )
{
     char com[150];
     int fbincharstr;
     long i = 0LU;
     FILE *fout = NULL;

     if ( ( fbincharstr = open ( s, O_RDWR ) ) == -1 )
     {
	  printf ( "Cannot open file %s. Exiting... \n", s );
	  exit ( 1 );
     }

     lseek ( fbincharstr, 0L, SEEK_SET );

     qsort_binary_character_string_file ( fbincharstr, counter, max_char );

     if ( close ( fbincharstr ) == -1 )
	  exit ( 1 );

     if ( ( fout = fopen ( "outs", "w" ) ) == NULL )
     {
	  printf ( "Cannot open file outs with fout. Exiting... \n" );
	  exit ( 1 );
     }

     if ( ( fbincharstr = open ( s, O_RDONLY ) ) == -1 )
     {
	  printf ( "Cannot open file outs. Exiting... \n" );
	  exit ( 1 );
     }

     for ( i = 0; i < counter; i++ )
     {
	  memset ( p, '\0', MAX_CHAR );
	  read ( fbincharstr, p, max_char );
	  fprintf ( fout, "%s\n", p );
     }

     if ( close ( fbincharstr ) == -1 )
	  exit ( 1 );
     if ( fclose ( fout ) == EOF )
	  exit ( 1 );

     sprintf ( com, "mv -f outs %s\n", s );
     if ( system ( com ) == -1 )
	  exit ( 1 );

     return 0;
}

//------------------------------------------------------------------------------

void
qsort_binary_character_string_file ( int fbincharstr, long count, unsigned int max_char )
{
     qs_binary_character_string_file ( fbincharstr, 0L, count - 1L, max_char );
}

//------------------------------------------------------------------------------
void
qs_binary_character_string_file ( int fbincharstr, long left, long right, unsigned int max_char )
{

     register long i = 0LU, j = 0LU;
     register long check = 0LU;
     register unsigned int k = 0LU;
     register int ok = 0;
     char *x = NULL, *y = NULL;
     char *a = NULL, *b = NULL;

     x = calloc ( max_char, sizeof ( char ) );
     y = calloc ( max_char, sizeof ( char ) );
     a = calloc ( max_char, sizeof ( char ) );
     b = calloc ( max_char, sizeof ( char ) );

     i = left;
     j = right;
     lseek ( fbincharstr, ( ( i + j ) / 2L ) * (long)(max_char), SEEK_SET );
     read ( fbincharstr, x, max_char );
     do
     {
	  ok = -1;
          check = 0LU;
	  while ( ( ok == -1 ) && ( i < right ) )
	  {
	       if(check == 0LU)lseek ( fbincharstr, i * (long)(max_char), SEEK_SET );
	       read ( fbincharstr, y, max_char );
	       k = 0;
	       while ( k < max_char )
	       {
		    if ( y[k] > x[k] )
		    {
			 ok = 1;
			 break;
		    }
		    if ( y[k] < x[k] )
		    {
			 ok = -1;
			 break;
		    }
		    if ( ( y[k] == '\0' ) && ( x[k] == '\0' ) )
		    {
			 ok = 0;
			 break;
		    }
                    k++;
	       }
	       if ( ( ok == -1 ) && ( i < right ) )
               {
		    i++;
                    check++;
               }
	  }
////////////////////////////////////////////////////////////////////////////////
	  ok = 1;
          check = 0LU;
	  while ( ( ok == 1 ) && ( j > left ) )
	  {
	       if(check == 0LU)lseek ( fbincharstr, j * (long)(max_char), SEEK_SET );
	       else lseek ( fbincharstr, (-2L) * (long)(max_char), SEEK_CUR );
	       read ( fbincharstr, y, max_char );
	       k = 0;
	       while ( k < max_char )
	       {
		    if ( y[k] > x[k] )
		    {
			 ok = 1;
			 break;
		    }
		    if ( y[k] < x[k] )
		    {
			 ok = -1;
			 break;
		    }
		    if ( ( y[k] == '\0' ) && ( x[k] == '\0' ) )
		    {
			 ok = 0;
			 break;
		    }
                    k++;
	       }
	       if ( ( ok == 1 ) && ( j > left ) )
               {
		    j--;
                    check++;
               }
	  }
	  if ( i <= j )
	  {
	       lseek ( fbincharstr, i * (long)(max_char), SEEK_SET );
	       read ( fbincharstr, a, max_char );
	       lseek ( fbincharstr, (j-(i+1))* (long)(max_char), SEEK_CUR );
	       read ( fbincharstr, b, max_char );
	       lseek ( fbincharstr, (-1L) * (long)(max_char), SEEK_CUR );
	       write ( fbincharstr, a, max_char );
	       lseek ( fbincharstr, (i-(j+1)) * (long)(max_char), SEEK_CUR );
	       write ( fbincharstr, b, max_char );
	       i++;
	       j--;
	  }
     }
     while ( i <= j );

     free ( x );
     x = NULL;
     free ( y );
     y = NULL;
     free ( a );
     a = NULL;
     free ( b );
     b = NULL;

     if ( left < j )
	  qs_binary_character_string_file ( fbincharstr, left, j, max_char );
     if ( i < right )
	  qs_binary_character_string_file ( fbincharstr, i, right, max_char );
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------EOF---------------------------------------------
